##{hheader.snp}
#include <owl\owlpch.h>
#pragma hdrstop

##@QUERY_APPL_OLE_AUTO 2
#include <ocf\automacr.h>

##@OPT_APPL_DRAGDROP 2
#include <classlib\bags.h>

##--BEGIN-- @OPT_APPL_PRINTING
#include "apxprint.h"
#include "apxprev.h"
##--END-- @OPT_APPL_PRINTING

##QUERY_FILENAME_CPP [[FileName]]
#include "[[FileName]].rh"            // Definition of all resources.


##{dragdrop.owl}
##--BEGIN-- @QUERY_APPL_COMMENT == VALUE_VERBOSE
//
// FrameWindow must be derived to override Paint for Preview and Print.
//
##--END-- @QUERY_APPL_COMMENT == VALUE_VERBOSE
//{{TDecoratedFrame = SDIDecFrame}}
class SDIDecFrame : public TDecoratedFrame {
public:
    SDIDecFrame (TWindow *parent, const char far *title, TWindow *clientWnd, bool trackMenuSelection = false, TModule *module = 0);
    ~SDIDecFrame ();
##--BEGIN-- ((@QUERY_APPL_MODEL == VALUE_DIALOG) && (@OPT_APPL_TOOLBAR || @OPT_APPL_STATUSBAR))

//{{[[TApplication]]VIRTUAL_BEGIN}}
public:
    virtual void SetupWindow ();
##:DBVirtual("SDIDecFrame", "SetupWindow")
//{{[[TApplication]]VIRTUAL_END}}
##--END-- ((@QUERY_APPL_MODEL == VALUE_DIALOG) && (@OPT_APPL_TOOLBAR || @OPT_APPL_STATUSBAR))
};    //{{SDIDecFrame}}


//{{TApplication = [[TApplication]]}}
class [[TApplication]] : public TApplication {
private:
##--BEGIN-- @QUERY_APPL_MODEL != VALUE_DIALOG
##QUERY_WIND_CLIENT [[ClientClass]]
##<<*ClientClass QUERY_BASE_NAME [[BaseClient]]
##BaseClient == "TListBox" 2

    void LoadTextFile ();                               // Read a file for ListBox client.
##--END-- @QUERY_APPL_MODEL != VALUE_DIALOG
##@OPT_APPL_HELP 3
    bool            HelpState;                          // Has the help engine been used.
    bool            ContextHelp;                        // SHIFT-F1 state (context sensitive HELP)
    HCURSOR         HelpCursor;                         // Context sensitive help cursor

##(((@QUERY_APPL_MODEL == VALUE_DIALOG) && @QUERY_APPL_DLGCLIENT_MENU) || (@QUERY_APPL_MODEL != VALUE_DIALOG))
##--BEGIN-- @OPT_APPL_TOOLBAR || @OPT_APPL_DRAGDROP
##@OPT_APPL_TOOLBAR
    void SetupSpeedBar (TDecoratedFrame *frame);
##@OPT_APPL_DRAGDROP
    void AddFile (const char *fileName);

##--END-- @OPT_APPL_TOOLBAR || @OPT_APPL_DRAGDROP
public:
    [[TApplication]] ();
    virtual ~[[TApplication]] ();

##@QUERY_APPL_MODEL != VALUE_DIALOG
    TOpenSaveDialog::TData FileData;                    // Data to control open/saveas standard dialog.
##@QUERY_APPL_OLE_AUTO 2
    TAppDescriptor  *Factory;                           // Automation descriptor.

##@QUERY_APPL_MODEL != VALUE_DIALOG
    void OpenFile (const char *fileName = 0);
##@OPT_APPL_PRINTING 4
    // Public data members used by the print menu commands and Paint routine in MDIChild.
    TPrinter        *Printer;                           // Printer support.
    int             Printing;                           // Printing in progress.

//{{[[TApplication]]VIRTUAL_BEGIN}}
public:
    virtual void InitMainWindow();
##:DBVirtual(\\"[[TApplication]]", "InitMainWindow")
##--BEGIN-- @OPT_APPL_DRAGDROP
    virtual void InitInstance();
##:DBVirtual(\\"[[TApplication]]", "InitInstance")
##--END-- @OPT_APPL_DRAGDROP
##@OPT_APPL_HELP 2
##:DBVirtual(\\"[[TApplication]]", "CanClose")
    virtual bool CanClose ();
##:DBVirtual(\\"[[TApplication]]", "ProcessAppMsg")
    virtual bool ProcessAppMsg (MSG& msg);
//{{[[TApplication]]VIRTUAL_END}}

//{{[[TApplication]]RSP_TBL_BEGIN}}
protected:
##--BEGIN-- @QUERY_APPL_MODEL != VALUE_DIALOG
    void CmFileNew ();
    void CmFileOpen ();
##@OPT_APPL_PRINTING 4
    void CmFilePrint ();
    void CmFilePrintSetup ();
    void CmFilePrintPreview ();
    void CmPrintEnable (TCommandEnabler &tce);
##--END-- @QUERY_APPL_MODEL != VALUE_DIALOG
##@OPT_APPL_HELP 2
    void CmHelpContents ();
    void CmHelpUsing ();
    void CmHelpAbout ();
##@OPT_APPL_DRAGDROP
    void EvDropFiles (TDropInfo drop);
##@OPT_APPL_PRINTING
    void EvWinIniChange (char far* section);
//{{[[TApplication]]RSP_TBL_END}}
##--BEGIN-- @QUERY_APPL_OLE_AUTO

DECLARE_AUTOCLASS([[TApplication]])
AUTODETACH
//{{[[TApplication]]AUTO_TBL_BEGIN}}
//{{[[TApplication]]AUTO_TBL_END}}

##--END-- @QUERY_APPL_OLE_AUTO
DECLARE_RESPONSE_TABLE([[TApplication]]);
};    //{{[[TApplication]]}}
##{hfooter.snp}
